/** @file sys_main.c 
*   @brief Application main file
*   @date 9.Sep.2014
*   @version 04.01.00
*
*   This file contains an empty main function,
*   which can be used for the application.
*/

/* (c) Texas Instruments 2009-2014, All rights reserved. */

/* USER CODE BEGIN (0) */
/* USER CODE END */

/* Include Files */

#include "sys_common.h"

/* USER CODE BEGIN (1) */
#include "sci.h"
#include "adc.h"
#include "stdlib.h"
unsigned char command[8];
/* USER CODE END */

/** @fn void main(void)
*   @brief Application main function
*   @note This function is empty by default.
*
*   This function is called after startup.
*   The user can use this function to implement the application.
*/

/* USER CODE BEGIN (2) */
/* USER CODE END */

void main(void)
{
/* USER CODE BEGIN (3) */
	adcData_t adc_data; //ADC Data Structure
	adcData_t *adc_data_ptr = &adc_data; //ADC Data Pointer
	unsigned int NumberOfChars, value; //Declare variables
	sciInit(); //Initializes the SCI (UART) module
	adcInit(); //Initializes the ADC module
	while(1) // Loop to acquire and send ADC sample data via the SCI (UART)
	{
	adcStartConversion(adcREG1, 1U); //Start ADC conversion
	while(!adcIsConversionComplete(adcREG1, 1U)); //Wait for ADC conversion
	adcGetData(adcREG1, 1U, adc_data_ptr); //Store conversion into ADC pointer
	value = (unsigned int)adc_data_ptr->value;
	NumberOfChars = ltoa(value,(char *)command);
	sciSend(scilinREG, 2, (unsigned char *)"0x"); //Sends '0x' hex designation chars
	sciSend(scilinREG, NumberOfChars, command); //Sends the ambient light sensor data
	sciSend(scilinREG, 2, (unsigned char *)"\r\n"); //Sends new line character
	}
/* USER CODE END */
}

/* USER CODE BEGIN (4) */
/* USER CODE END */
